#ifndef MY_ABC_HERE
#define MY_ABC_HERE
#endif
/* modechange.h -- definitions for file mode manipulation

   Copyright (C) 1989-1990, 1997, 2003-2006, 2009-2018 Free Software
   Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

#if ! defined MODECHANGE_H_
# define MODECHANGE_H_

# include <stdbool.h>
# include <sys/types.h>

#ifdef MY_ABC_HERE
# include <synoacl/synoacl.h>
#endif

struct mode_change *mode_compile (const char *);
struct mode_change *mode_create_from_ref (const char *);
mode_t mode_adjust (mode_t, bool, mode_t, struct mode_change const *,
                    mode_t *);

#ifdef MY_ABC_HERE
struct mode_change *mode_compile_acl (char *, bool);
SYNO_ACL *get_acl_from_mode_change (struct mode_change *);
SYNO_ACL *trf_mode_to_acl(struct mode_change *, const struct stat*);
SYNO_ACL *acl_adjust (SYNO_ACL *, SYNO_ACL *, int *, struct mode_change*);
#endif


#endif
